/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 3, 2004, 3:07:00 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.parser;

import isac.kestore.KEStoreServices;
import isac.util.Formalization;
import isac.util.parser.FormalizationDigest;

import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author Walther Neuper Sep 3, 2004, 3:07:00 PM
 */
public class TestFormalizationDigest extends TestCase {

    /**
     * parse the formalization of the 'minisubpbl' example
     * 
     * @see isac.kestore.TestKEStoreServices#testLoadContentMinisubpbl() for how
     *      an XML-file of an example is fetched
     * 
     * @see isac.bridge.TestBridge#testMinisubpblAutoCalc for how the
     *      Formalization is used to start an example
     *  
     */
    public void testParseExplMini() {
        System.out.println("---BEGIN isac.util.parser.TestFormalizationDigest");

        //see isac.kestore.TestKEStoreServices#testLoadContentMinisubpbl()
        KEStoreServices ks = new KEStoreServices("isac/xmldata");
        Vector vec = ks.loadContent("exp", "exp_IsacCore_Tests_1b.xml");

        //parse the content
        String xmlstr = (String) vec.firstElement();
        FormalizationDigest fd = new FormalizationDigest();
        Formalization fmz = fd.parseFormalization((String) xmlstr);

        System.out.println("fmz = " + fmz.toSMLString());
        String test = "[([\"equality (x+1=2)\", \"solveFor x\", \"solutions L\"],"
                + "(\"Test.thy\","
                + "[\"sqroot-test\",\"univariate\",\"equation\",\"test\"],"
                + "[\"Test\",\"squ-equ-test-subpbl1\"]))]";
        String s1 = test;
        String s2 = fmz.toSMLString();
        char c1, c2;
        for (int i = 0; i < s2.length(); i++) {
            c1 = s1.charAt(i);
            c2 = s2.charAt(i);
            if (c1 == c2) {
                System.out.println("equal " + c1 + ' ' + ' ' + c2);
            } else {
                System.out.println("Unequ " + c1 + ' ' + ' ' + c2);
            }
        }
        assertEquals("xmlstr --> fmz", test, fmz.toSMLString());
    }

}