/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.browser;

import isac.util.InformationProcessor;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.*;

import org.apache.log4j.Logger;

/**
 * Displays the content information of examples, methods, problems in HTML
 * format.
 * 
 * @author Mario Hochreiter
 * @version 1.0
 *  
 */
public class ContentPanel extends JPanel {

    static Logger logger = Logger.getLogger(ContentPanel.class.getName());

    protected JEditorPane content_pane_;

    protected String session_id_;

    public ContentPanel(String sessionId) {
        this.session_id_ = sessionId;
        content_pane_ = new JEditorPane();
        content_pane_.setPreferredSize(new Dimension(640, 480));
        //  content_pane_.setContentType("text/html");
        JScrollPane sp = new JScrollPane(content_pane_);
        this.setLayout(new BorderLayout());
        this.add(sp, BorderLayout.CENTER);
    }

    public void setContent(String type, String xmlFile) {
        String xmlString = InformationProcessor.loadXML(session_id_, type,
                xmlFile);
        content_pane_.setText(xmlString);
    }
}