/*
 * Created on Sep 19, 2003
 */
package isac.util.formulae;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Vector;

/**
 * string lists pointing into the KEStore (WN05 not yet theories). The string
 * list is unique within one KEStore; it can be used as a key into the
 * hierachies.
 * 
 * @see <isac.util.formulae.CalcHead>, <isac.gui.calcheadviews.CalcHeadView>
 *  
 */
public class KEStoreID implements Serializable {

    protected Vector id_ = new Vector();

    public Vector getID() {
        return id_;
    }

    public void setID(Vector v) {
        id_ = v;
    }

    public void addString(String id) {
        this.id_.add(id.trim());
    }

    /**
     * Format the object in a way that the bridge can handle it
     * 
     * @return SML representation (is NOT a Java-String)
     */
    public String toSMLString() {
        if (id_.isEmpty()) {
            return "[]";
        } else {
            StringBuffer sb = new StringBuffer();
            Iterator it = id_.iterator();
            sb.append("[");
            while (it.hasNext()) {
                sb.append("\"");
                sb.append(it.next());
                sb.append("\",");
            }
            sb.deleteCharAt(sb.length() - 1); // remove last ","
            sb.append("]");
            return sb.toString();
        }
    }

    public String toString() {
        String content = "<KEY>\n";//TODO.WN041001 drop that XML
        Iterator vectit = id_.iterator();
        while (vectit.hasNext()) {
            content += "<ID>" + vectit.next() + "</ID>\n";//TODO.WN041001 drop
            // that XML
        }
        content += "</KEY>\n";//TODO.WN041001 drop that XML

        return content;
    }

    public boolean equals(Object o) {
        if (o instanceof KEStoreID)
            return this.getID().equals(((KEStoreID) o).getID());
        else
            return false;
    }

}