/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper
 * created Jun 17, 2005 6:47:05 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;


/**
 * @author neuper
 * 
  */
public class Model extends CalcElement {

    private ModelItemList given_, where_, find_, relate_;

    public Model() {
        given_ = new ModelItemList();
        where_ = new ModelItemList();
        find_ = new ModelItemList();
        relate_ = new ModelItemList();
    }

    /**
     * @see isac.util.CalcElement#getMathML()
     * @deprecated because it does NOT make sense for a whole Model
     */
    public String getMathML() {
        return null;
    }

    /**
     * @see isac.util.CalcElement#getType()
     */
    public int getType() {
        return CALCEL_MODEL;
    }

    //get*-----------------------------------------------------------
    public ModelItemList getFind() {
        return find_;
    }

    public ModelItemList getWhere() {
        return where_;
    }

    public ModelItemList getGiven() {
        return given_;
    }

    public ModelItemList getRelate() {
        return relate_;
    }

    //set*-----------------------------------------------------------
    public void setFind(ModelItemList el) {
        find_ = el;
    }

    public void setWhere(ModelItemList el) {
        where_ = el;
    }

    public void setGiven(ModelItemList el) {
        given_ = el;
    }

    public void setRelate(ModelItemList el) {
        relate_ = el;
    }

    /**
     * @return String including all data, i.e 'Where' and item_status_, too,
     *         which is too much for SMK-input
     * 
     * @see isac.util.interfaces.ICalcElement#toSMLString()
     */
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("Given ");
        sb.append(given_.toString());
        sb.append(", Where ");
        sb.append(where_.toString());
        sb.append(", Find ");
        sb.append(find_.toString());
        sb.append(", Relate ");
        sb.append(relate_.toString());
        return sb.toString();
    }

    /**
     * @return String to be sent to the stdin of SML running the math-engine
     *         FIXME embraced by '()' instead of ???
     * 
     * @see isac.util.interfaces.ICalcElement#toSMLString()
     */
    public String toSMLString() {
        StringBuffer sb = new StringBuffer();
        sb.append("");
        sb.append("Given ");
        sb.append(given_.toSMLString());
        sb.append(", Find ");
        sb.append(find_.toSMLString());
        sb.append(", Relate ");
        sb.append(relate_.toSMLString());
        sb.append("");
        return sb.toString();
    }

}