/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Mar 12, 2005 3:09:15 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.users;

import isac.util.formulae.CalcHead;

import java.rmi.RemoteException;

/**
 * @author Walther Neuper
 * 
 * semantics for review by AK
 */
public interface IUserSettings {

	//TODO comments with AK?
	//public static final String start_worksheet = "start_worksheet";

	//the following are situations implemented as keys for UserSettings
	//the identifiers must start with "KEYn_*" where n reappears in the
	// identifiers of the related values "VALn_*" ---------------------
	public static final String KEY1_START_SPECIFY = "KEY1_START_SPECIFY";

	/**
	 * _ALL_ the values of UserSettings _MUST_ be connect their
	 * Integer-representation with the String-representation in
	 * 
	 * @see isac.util.users.UserSettings#createValstrValint
	 */
	public static final int VAL1_SKIP_SPECIFY_TO_START_SOLVE = 23;

	public static final int VAL1_POP_CALCHEAD_WITH_DESCRIPTIONS = 26;

	//-----------------------------------------------------------------
	public static final String KEY2_NEXT_BUTTON = "KEY2_NEXT_BUTTON";

	public static final int VAL2_FORMULAE_ONLY = 43;

	public static final int VAL2_FORMULA_TACTIC_FORMULA_ = 46;

	public static final int DUMMY = 0;

	//-----------------------------------------------------------------
	public int getValue(String key);

	public boolean setValue(String key, int value);

}