(*.evaluate isac (all the code of the kernel) and isactest
   (c) Walther Neuper 1997

  /usr/local/Isabelle2002/bin/isabelle HOL-Real-Isac

  /usr/local/Isabelle2002/bin/isabelle HOL-Real
  cd"~/proto2/isac/src/sml";
  use"ROOT.ML";

.*)

(*.please change accordingly, if you store a new heap ...*)
val version_kernel = "sml-05048 corr: get_interval, replaceFormula";

print_depth 3;(*reduces verbosity of stdout*)

(*.this function from Isabelle2002/src/Pure/library.ML is overwritten
  by some Isabelle2002 theory file; thus reestablished for isac.*)
fun find_first _ [] = None
  | find_first pred (x :: xs) =
    if pred x then Some x else find_first pred xs;

"**** build the isac kernel = math-engine + IsacKnowledge ";
"**** build the math-engine ******************************";
use"library.sml";
use"definitions.sml";(*extracted from Scripts for simple re-evaluation*)
cd "Scripts";
 	use"term_G.sml";
 	use"calculate.sml";
 	use"rewrite.sml";
 	use"reverse-rew.sml";
 	use_thy"Script";
(*      remove_thy"ListG";
 	remove_thy"Script";
 	use_thy"Scripts/Script";
 	*)
 	use"scrtools.sml";
 	cd ".."; 
use"globals.sml"; (*extracted from ME for simple re-evaluation*)
cd "ME";
 	use"mstools.sml";
 	use"ctree.sml";
 	use"ptyps.sml"; 
 	use"generate.sml";
 	use"modspec.sml";
 	use"appl.sml";
 	use"script.sml";
 	use"solve.sml";
	use"inform.sml"; 
 	cd ".."; 
use"states"; (*extracted from FE for simple re-evaluation*)
cd "xmlsrc";
 	use"mathml.sml";
 	use"datatypes.sml";        
 	use"pbl-met-hierarchy.sml";      
 	use"interface-xml.sml";
 	cd "..";
cd"FE-interface";
 	use"messages.sml";
 	use"sml.sml";
	use"interface.sml";
 	cd "..";
use"print_exn_G.sml";
"**** build math-engine complete *************************";
 
"**** build the IsacKnowledge ****************************";
 cd "IsacKnowledge";
 	use_thy"Isac"; (*evaluates ALL thys depending on the root 'Isac'*)

 (*     remove_thy"Typefix";
 	use_thy"IsacKnowledge/Isac";
	use_thy"Isac";
        *)
 	cd "../";
"**** build IsacKnowledge complete ***********************";
"**** build isac kernel complete *************************";
 
"**** run the tests **************************************";
cd "systest";
(*+ check kbtest/diffapp.sml for additional items in met-model*)
        use"ctree.sml";
       	use"calculate.sml"; 
        use"details.sml"; (*can notyet ackn. 'Rewrite_Set "cancel"' *);
       	use"root-equ.sml"; 
       	use"modspec.sml"; 
       	use"script.sml";   
	(* use"script_if.sml"; WN03 missing: is_rootequation_in*)
       	use"scriptnew.sml";     
       	use"refine.sml";	       
       	use"subp-rooteq.sml";   
       	use"list_rls.sml"; 
        use"auto-inform.sml";
	use"tacis.sml";
	use"me.sml";
	use"interface-xml.sml";
 	use"FE-interface.sml";     
	(* use"testdaten.sml"; no update after dropping 'errorBound'*)    
 	cd "../";
(*TODO copy the whole filestructure from sml to smltest*)
cd"../smltest/Scripts";
 	use"calculate.sml";
 	cd "../.."; 
"**** run systests complete ******************************";

(*----------WN040311 list_rls.sml doesnt work at other pos
 cd "systest";
 (*+ check kbtest/diffapp.sml for additional items in met-model*)
 	use"FE-interface.sml";     
        use"auto-inform.sml";
 	use"calculate.sml";
val me = meOLD;
        use"details.sml"; (*can notyet ackn. 'Rewrite_Set "cancel"' *)
val me = meNEW; (*see FIXXXXXME.040216*)
 	use"list_rls.sml"; WN040311.doesnt work at other pos
        use"ptree.sml";
 	use"refine.sml";	       
 	use"root-equ.sml";
 	use"script.sml";   
     (* use"script_if.sml";   missing: is_rootequation_in*)
 	use"scriptnew.sml";     
 	use"subp-rooteq.sml";   
      (*use"testdaten.sml"; no update after dropping 'errorBound'*)    
 	"******* systests complete *******";
 	cd "../";
----------------------------------------------------------------------*)

 cd"sml/kbtest";
 	use"complex.sml";
 	use"diff.sml";
 	use"diffapp.sml"  (*meNEW: fmz <> []: nxt <> Add_Relation (a/2)^2.. *);
	(*use"inssort.sml"; problems with recdef in Isabelle2002*)
 	use"logexp.sml";
 	use"poly.sml";
 	use"polyeq.sml";  (*TODO 31.b, n1., 44.a, 1.a~, 1.b (all'expanded')WN
 			     ? also check others without check 'diff.behav.'*);
 	use"rateq.sml";
 	use"rational.sml" (*TODO add_fractions_p throws overflow-exn      WN*);
 	use"rlang.sml";    (*WN.12.6.03: for TODOs search 'writeln', 
 			     for simplification search MG 
 		 erls:       98a(1) 104a(1) 104a(2) 68a *);
 	use"root.sml";
 	use"rooteq.sml";
 	use"rootrateq.sml";
 	use"termorder.sml";
 	use"trig.sml";
 	use"vect.sml";  
	use"wn.sml";              
 	cd "../";
 states:=[];
"**** run kbtests complete *******************************";
"=========================================================";

"**** build math-engine complete *************************";
"**** build IsacKnowledge complete ***********************";
"**** run systests complete ******************************";
"**** run kbtests complete *******************************";
"**** build isac kernel + run tests complete *************";



(****************************************************************************
WN.notebook: SMLNJ
-----------------------------------------------------------------------------
  cd ~/isabelle-smlnj/heaps/smlnj-110_x86-linux/
  sml @SMLload=02-HOL-Real-isac
  cd"~/develop/sml/";
  use"ROOT.ML";

*****************************************************************************
WN.notebook: create HTML representation for theory files fr Isac
-----------------------------------------------------------------------------
  su
  cd /home/neuper/develop
  mv sml Isac
-----
  /usr/local/Isabelle2002/bin/isatool usedir -i true HOL-Real /home/neuper/develop/Isac/
  (*^^^ does not create a new heap !!!*)

*****************************************************************************
export of problems and methods from sml to xml
-----------------------------------------------------------------------------
  > pwd();
  val it = "/home/neuper/develop/sml" : string
  pbl_hierarchy2file "../xml/pbl/";
  pbls2file "../xml/pbl/";
  met_hierarchy2file "../xml/met/";
  mets2file "../xml/met/";
 
*****************************************************************************
WN.notebook: create a new heap (PolyML overwritesHOL-Real-Isac !)
-----------------------------------------------------------------------------
  su
  cd /usr/local/Isabelle2002/heaps/polyml-4.1.3_x86-linux
  cp HOL-Real HOL-Real-Isac
  /usr/local/Isabelle2002/bin/isabelle HOL-Real-Isac
  cd"/home/neuper/proto2/isac/src/sml";
  use"ROOT.ML";
*****************************************************************************)